"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var gun_sear_1 = require("@notabug/gun-sear");
var chaingun_1 = require("@notabug/chaingun");
var ChainGunUserApi_1 = require("./ChainGunUserApi");
var ChainGunSear = /** @class */ (function (_super) {
    __extends(ChainGunSear, _super);
    function ChainGunSear(graph, LinkClass) {
        if (LinkClass === void 0) { LinkClass = chaingun_1.ChainGunLink; }
        var _this = _super.call(this, graph, LinkClass) || this;
        _this.registerSearMiddleware();
        return _this;
    }
    ChainGunSear.prototype.registerSearMiddleware = function () {
        this.graph.use(gun_sear_1.unpackGraph);
    };
    ChainGunSear.prototype.user = function () {
        return (this._user = this._user || new ChainGunUserApi_1.ChainGunUserApi(this));
    };
    return ChainGunSear;
}(chaingun_1.ChainGun));
exports.ChainGunSear = ChainGunSear;
//# sourceMappingURL=ChainGunSear.js.map